// AutoBev.java
// AutoBev kiosk emulated on smartphone
// ND EE Senior Design May 2011
// Alex Macomber, Liz Clark, Lori Garcia, Mark Pomerenke

package autoBev.android;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.text.DecimalFormat;
import java.util.Enumeration;
import java.net.NetworkInterface;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;

import android.content.SharedPreferences;

public class AutoBev extends Activity {
	Thread UDPserverThread ;
	// Preference file used for saving variables
    public static final String PREFS_NAME = "MyPrefsFile";
    
	// Define buttons,checkboxes and textboxes so they can be changed later
	public Button button2,button3,button4,button01,button02,button03;
	CheckBox checkBox1,checkBox2;
	private EditText username, pin;
	
	// Client/server vars
	DatagramSocket socket;
	DatagramPacket packet;
	InetAddress address;
	
	// global vars
	boolean receive = false;
	String[] rcvMessage = {"0"};
	
	// Define prices and drinks
	double[] prices = new double[] {1.00,1.50,1.00,2.99,5.00,1.00,0.50};	
	String[] drinks = new String[] {"Coke", "Diet Coke", "Root Beer Float", "Lemonade","Sprite", "Dr. Pepper"};

	// Set decimal format so prices show up as $X.XX
	DecimalFormat priceFormatter = new DecimalFormat("$#0.00");

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		// Set buttons to show drink name and price
		button2 = (Button) this.findViewById(R.id.button2);button3 = (Button) this.findViewById(R.id.button3); button4 = (Button) this.findViewById(R.id.button4);
		button01 = (Button) this.findViewById(R.id.Button01); button02 = (Button) this.findViewById(R.id.Button02); button03 = (Button) this.findViewById(R.id.Button03);
		button2.setText(drinks[0]+"\n"+priceFormatter.format(prices[0])); button3.setText(drinks[1]+"\n"+priceFormatter.format(prices[1])); button4.setText(drinks[2]+"\n"+priceFormatter.format(prices[2]));
		button01.setText(drinks[3]+"\n"+priceFormatter.format(prices[3])); button02.setText(drinks[4]+"\n"+priceFormatter.format(prices[4])); button03.setText(drinks[5]+"\n"+priceFormatter.format(prices[5]));
		
		// Initialize checkboxes
		checkBox1 = (CheckBox) findViewById(R.id.checkBox1);
		checkBox2 = (CheckBox) findViewById(R.id.checkBox2);
		
		// Initialize textboxes
		username = (EditText) findViewById(R.id.editText1);
		pin = (EditText) findViewById(R.id.editText2);
        UDPserverThread = new Thread(new Runnable() { public void run() { UDPServer(); }});
        UDPserverThread.start();
        
	} // End onCreate

/////// Load previously saved username/password
	protected void onResume(){
	    super.onResume();
	    SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
	    String savedUserName = settings.getString("username", "");
	    String savedPin = settings.getString("pin", "");
	    username.setText(savedUserName);
	    pin.setText(savedPin);
	}

	
//////// These methods are called on button click //////// 
	public void drink1_clicked(View view) {	// User clicked Drink 1
		sendToServer(drinks[0],prices[0]);
	}
	public void drink2_clicked(View view) {	// User clicked Drink 2
		sendToServer(drinks[1],prices[1]);
	}
	public void drink3_clicked(View view) {	// User clicked Drink 3
		sendToServer(drinks[2],prices[2]);
	}
	public void drink4_clicked(View view) {	// User clicked Drink 4
		sendToServer(drinks[3],prices[3]);
	}
	public void drink5_clicked(View view) {	// User clicked Drink 5
		sendToServer(drinks[4],prices[4]);
	}
	public void drink6_clicked(View view) {	// User clicked Drink 6
		sendToServer(drinks[5],prices[5]);
	}
	
	// Function that sends drink to server
	public void sendToServer(final String drink, double price){

		// Convert double to string
		final String cost = Double.toString(price);
		
		Log.i("UDP","S: send to server");
		// Check if username/pin is of correct format
		boolean correctInfo = true;
		// Check if username is all letters
		if ((!isLetters(username.getText().toString()) || username.getText().toString().length() == 0)) {
			alertbox("Your username must contain letters only.");
			correctInfo = false;
		}
		// Check if pin is a 4 digit number
		if ((correctInfo) && ((!isInteger(pin.getText().toString())) || (numDigits(pin.getText().toString()) != 4))) {
			alertbox("Your pin must be 4 numbers.");
			correctInfo = false;
		}
        
		// If the information is correct open a dialog box and send order to server
		if (correctInfo) {	
			    // Open dialog to confirm order
				Builder builder = new AlertDialog.Builder(this);
				builder.setMessage("This will charge your credit card " + priceFormatter.format(price) + ".  Proceed?")
					.setCancelable(true)
					
					// if they click yes below code runs
					.setPositiveButton("Yes, order a " + drink,
							new DialogInterface.OnClickListener() {
								@Override
								
								public void onClick(DialogInterface dialog,
										int which) {
									// Save username and password
						        	saveInformation(); 
						        	
									// Send drink to server
									Log.i("UDP","S: sending");
									UDP_Send(drink, cost);
									
							        // wait til receive from bartender
									int n = 0; double y; int limit = 100000000;
							       if (!receive) {
							        	while (!receive & n < limit) {  
							        		n++; y = 3*3*2.3+56; // this is used to timeout if no response
							        	} // timeout after certain amount of itme
							        }
							        
							        // If no response, start over
							        if (n >= limit) {
							        	alertbox("There was no response from the bartender.  Please try again.");
							        }
							        // if there is a response
							        else {
								        Log.i("UDP", "S: " +rcvMessage[0]);
								        
								        // If order went through
								        if (rcvMessage[0].equals("1")) {
								        	if (rcvMessage[2].equals("1")){
								        		alertbox("Thank you for your purchase!  You are order #" + rcvMessage[1] +
								        			". There is 1 order before you." +
								        			" You will receive a text message when your drink is ready.");
								        	}
								        	else {
								        		alertbox("Thank you for your purchase!  You are order #" + rcvMessage[1] +
								        			". There are " + rcvMessage[2] + " orders before you." +
								        			" You will receive a text message when your drink is ready.");
								        	}
								        }
								        // If username was wrong
								        else if(rcvMessage[0].equals("2")) {
								        	alertbox("The username \"" + username.getText().toString() + 
								        			"\" does not exist.  Please setup an account at an " +
								        			"AutoBev kiosk and try ordering a " + drink + " again.  " +
								        			"Your credit card has not been charged.");
								        }
								        // If password was wrong
								        else if(rcvMessage[0].equals("3")) {
								        	alertbox("Your password did not match the saved password for username " +
								        			"\"" + username.getText().toString() + "\".  Please try ordering a " + 
								        			drink + " again.  Your credit card has not been charged.");
								        }
							        } // end else
							        // reset receive flag
							        receive = false;								
								}
					})
					// If they click no, nothing happens
					.setNegativeButton("No",
							new DialogInterface.OnClickListener() {
								@Override
								public void onClick(DialogInterface dialog,
										int which) {
									//////////////////////////////////////
									// if they click no this code runs //
									//////////////////////////////////////
								}
							}
					);
			
			AlertDialog dialog = builder.create();
			dialog.show();
		}
	}	// end sentToServer function

	
// Thread that is constantly receiving packets
    public void UDPServer()
    { 
    	while(true) {
	    	final String TAG = "UDP playback";
	    	try {
	    		Log.i(TAG, "S: inside try");
		        	byte[] buffer = new byte[140];
		        	int port = 9050;//50005;
	                // Create new UDP-Socket and packet
	                DatagramSocket socket = new DatagramSocket(port);
		        	DatagramPacket packet = new DatagramPacket(buffer, buffer.length );
		        	Log.i(TAG, "S: b4 receive");
                    // Receive the UDP-Packet	
	                socket.receive(packet);
	                Log.i(TAG, "S: after receive");
	                // Set flag to tell main code that message has been received
	                receive = true;
	                
	                //Log.i("UDP","S: " + new String(buffer));
	                rcvMessage = new String(buffer).split("#"); 
		        }
	    	
	    		catch (Exception e) {
		           //    Log.e(TAG, "S: Error", e);
	            }
	    	}
        }
	
//**************************** Functions ****************************//
	
////////// Function that sends UDP message to C# server /////////////
    public void UDP_Send(String drink, String cost){
		try {
	    	socket = new DatagramSocket();
		    address = InetAddress.getByName("10.40.136.93"); // this is IP address of host server
		    String port = "9050";
		    int pnum = Integer.parseInt(port);
		    byte[] messageBytes = new byte[0];
		 
		    // Get phone number of Droid
			String phoneNumber = "null";
			try {
				TelephonyManager tm = (TelephonyManager)
				getSystemService(Context.TELEPHONY_SERVICE);
			     Log.i("connect","S: beforeLine1Number");
			       phoneNumber = tm.getLine1Number();
			}
			catch (Exception e) {
		  		  Log.i("connect",e.toString());
			}
			
			// Get IP address of droid
			String IP = getIpAddress();
			Log.i("connect","S: before drinkComplete");
			phoneNumber = "eclark4@nd.edu";
			// Create complete message with num,username,pin, and order
			String drinkComplete = "&" + phoneNumber + "#" + IP + "#" + username.getText() + 
								   "#" + pin.getText() + "#" + drink + "#" + cost + "#" ;
			// Convert message to bytes
			messageBytes = drinkComplete.getBytes();
			
			// Create datagram packet
			Log.i("UDP","S: before datagram packet");
			packet = new DatagramPacket(messageBytes, messageBytes.length, address, pnum);
			packet.setLength(messageBytes.length);
			Log.i("UDP","S:" + drinkComplete);
			
			// send packet to server
			socket.send(packet);
			Log.i("UDP","S: after send");
			// close socket
			socket.close();
    }
			catch (IOException io) {
				
				Log.i("UDP","send message failed");
				Log.i("UDP",io.toString());
				
			}
    }
////////// Function that returns true if string is made up of all letters //////////
	public boolean isLetters(String str)
	{
		for(int i = 0; i < str.length(); i++)
		{
			int Ascii = (int)str.charAt(i);
			if(Ascii < 65 || Ascii > 122){ // check if it not a letter
				return false; }
		}
		return true;  // if all letters
	}
	
////////// Function that returns true if string is made up of all numbers //////////
	public boolean isInteger(String i)
	{
		try
		{
			Integer.parseInt(i);
			return true;
		}
		catch(NumberFormatException nfe)
		{
			return false;
		}
	}
	
////////// Function that returns number of digits in integer //////////
	public int numDigits(String str){
		int x = Integer.parseInt(str);
		int count = 0;
		while(x > 0)
		{
		   x  /= 10;
		   count++;
		}
		return count;
	}
	
////////// Function that displays alert box //////////////
	protected void alertbox(String mymessage)
	   {
	   new AlertDialog.Builder(this)
	      .setMessage(mymessage)
	      .setCancelable(true)
	      .setNeutralButton(android.R.string.ok,
	         new DialogInterface.OnClickListener() {
	         public void onClick(DialogInterface dialog, int whichButton){}
	         })
	      .show();
	   }
	
///////// Function that gets Ip address of device	
    public String getIpAddress() {
        try {
            for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en.hasMoreElements();) {
                NetworkInterface intf = en.nextElement();
                for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr.hasMoreElements();) {
                    InetAddress inetAddress = enumIpAddr.nextElement();
                    if (!inetAddress.isLoopbackAddress()) {
                    	 Log.d("local ip address", inetAddress.getHostAddress().toString());
                        return inetAddress.getHostAddress().toString();

                    }
                }
            }
        } catch (Exception E) {
        }
        return null;
    }
	
///////// Function that saves username and password
    public void saveInformation() {
	    if (checkBox1.isChecked()) {
	    	SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
	 	    SharedPreferences.Editor editor = settings.edit();
	 	    editor.putString("username",username.getText().toString());
	 	    editor.commit();
	    }
	    // Save pin if save checkbox is checked
	    if (checkBox2.isChecked()) {
	    	SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
	 	    SharedPreferences.Editor editor = settings.edit();
	 	    editor.putString("pin",pin.getText().toString());
	 	    editor.commit();
	    }
    }
} //end class